#ifndef _PRIMITIVE_TRAITS_H_
#define _PRIMITIVE_TRAITS_H_

#include <string>

namespace utakata {

    namespace interpreter {
    
        namespace primitive {

            template<class T>
            struct primitive_traits
            {
                // nameは各自で実装する必要があり、実装されていない場合にはコンパイル
                // エラーになる。
                typedef  T  primitive_type;
                static std::string name();

            };
        }  // primitive
    }  // interpreter
}  // utakata

#endif /* _PRIMITIVE_TRAITS_H_ */
